export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addInput("MomPeriod", InputType.int, 14);
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            MomBuffer : this.addBuffer(),
        };
    }

    onInit() {
        const  {MomPeriod} = this.getInputs();

        this.buffers.MomBuffer
            .setShape(Shape.Line)
            .setColor(Color.DodgerBlue)
            .setLabel("Mom(" + MomPeriod + ")")
            .setShortName("Mom(" + MomPeriod + ")")
            .setDrawBegin(MomPeriod)
        ;
    }

    async onUpdate() {
        const  {MomPeriod, PriceType} = this.getInputs(),
            {MomBuffer} = this.buffers,
            {Close} = await Bar.load([Bar.Mode.Close], PriceType),
            barSize = Close.length;

        let i, countedBars = Bar.counted();

        if (barSize <= MomPeriod) return 0;
        if (countedBars < 1) {
            for (i = 1; i <= MomPeriod; i++) {
                MomBuffer.set((barSize - i), 0);
            }
        }
        i = barSize - MomPeriod - 1;
        if (countedBars >= MomPeriod) {
            i = barSize - countedBars - 1;
        }

        while (i >= 0) {
            MomBuffer.set(i, (Close[i] * 100 / Close[i + MomPeriod]));
            i--;
        }
    }
}